from getDelApi import *
from DeliTag import *
from DeliPost import *
from pickle import *
from os import *

class DeliStore:
    def __init__(self,username,password):
        self.delitags = dict()
        self.recentposts = list()
        self.username = username
        self.password = password
        self.get_reversed = True
        self.sort_tag_func = DeliTag.getName
        self.fetchmethod = "net"
        self.succesfullmethod = "None"
        self.dumpfilename = getenv("HOME") + sep + ".delikrc"
        #self.sort_tag_func = DeliTag.getNumPosts


    def clear(self):
        self.delitags = dict()
        self.recentposts = list()

    def setUsername(self,username):
        self.username = username

    def setPassword(self,password):
        self.password = password

    def getTags(self):
        taglist = list()
        for delitag in self.delitags.itervalues():
            taglist.append(delitag)
        taglist.sort(key = self.sort_tag_func, reverse = self.get_reversed)
        return taglist

    def refreshData(self):
        print self.fetchmethod
        self.clear()
        if self.fetchmethod == "net":
            try:
                self.loadDataFromNet()
                self.succesfullmethod = "Internet"
            except:
                try:
                    self.loadDataFromDisk()
                    self.succesfullmethod = "Disk"
                except:
                    print "file does not exist"
                    raise

        if self.fetchmethod == "disk":
            try:
                self.loadDataFromDisk()
                self.succesfullmethod = "Disk"
            except:
                print "file does not exist"
                try:
                    self.loadDataFromNet()
                    self.succesfullmethod = "Internet"
                except:
                    raise

    def loadDataFromDisk(self):
            print "loading from disk"
            dumpfile = file(self.dumpfilename,"r")
            data = load(dumpfile)
            logindata = data[2]
            passworddata = data[3]
            dumpfile.close()
            if logindata != self.username or passworddata != self.password :
                raise
            self.delitags = data[0]
            self.recentposts = data[1]

    def loadDataFromNet(self, numrecents = 10, fetchmethod = "disk"):
        print "loading from net"
        dg = dataGrabber(self.username,self.password)
        a = dg.getTag()
        for b in a:
            self.delitags[b] = DeliTag(b)
        posts = dg.getPost()
        for post in posts:
            newpost = DeliPost(post['url'], post['desc'])
            tags = post['tag'].split()
            for tag in tags:
                try:
                    self.delitags[tag].addPost(newpost)
                except:
                    print "del.icio.us not in sync"
        self.recentposts = list()
        posts = dg.getRecentPost(numrecents)
        for post in posts:
            newpost = DeliPost(post['url'], post['desc'])
            self.recentposts.append(newpost)
        self.dumpData()

    def getRecentPosts(self):
        return self.recentposts

    def setSortMethod(self,method):
        if method == 1:
            self.sort_tag_func = DeliTag.getNumPosts
        if method == 0:
            self.sort_tag_func = DeliTag.getName

    def setReversed(self,reversed):
        self.get_reversed = reversed

    def getReversed(self):
        return self.get_reversed

    def renameTag(self, old, new):
        dg = dataGrabber(self.username, self.password)
        dg.renameTag(old, new)


    def dumpData(self):
            dumpfile = file(self.dumpfilename,"w")
            data = [self.delitags,self.recentposts,str(self.username),str(self.password)]
            dump(data, dumpfile)
            dumpfile.close()
