from kdeui import KSystemTray, KPopupMenu,KSelectAction,KAction
from kdecore import KApplication, KURL,KAboutData, KCmdLineArgs
from KDeliPrefs import *
from prefs import *
from getDelApi import *
from DeliStore import *
from KdeliTag import *
from inspect import *

class KDeliSysTray(KSystemTray):
    def __init__ (self,parent,title):
        KSystemTray.__init__(self, parent, title)
        self.startup = True
        # build the GUI
        self.tagspopupmenu = KPopupMenu()
        #icons = KIconLoader("prova",None)
        #self.setPixmap(icons.loadIcon("prova", KIcon.Desktop))
        self.setPixmap(QPixmap("deliK.xpm"))
        self.prefs = KDeliPrefs()
        self.prefdialog = PreferencesDiag(self)
        self.prefdialog.loadSettings()
        self.actionReload = KAction("Reload tags","reload_page")
        self.actionReload.plug(self.contextMenu())
        self.action_pref = KAction("Preferences")
        self.action_pref.plug(self.contextMenu())
        self.action_pref.setIcon("configure")
        self.aboutdata = KAction("About DeliK!")
        self.aboutdata.plug(self.contextMenu())
        self.aboutdata.setIcon("konqueror")
        self.aboutapplication = KAboutApplication(self)
        QObject.connect(self.actionReload, SIGNAL("activated()"),
                        self.refreshData)
        QObject.connect(self.action_pref, SIGNAL("activated()"),
                        self.prefdialog.show)
        QObject.connect(self.aboutdata, SIGNAL("activated()"),
                        self.aboutapplication.show)
        self.refresh_timer = QTimer(self)
        QObject.connect(self.refresh_timer, SIGNAL("timeout()"),
                        self.refreshData)
        self.deliTags = list()
        self.recentPosts = list()
        # build the tag menu and the other related stuff.
        self.refresh_timer.start(self.prefs.getReloadTime()*60000, False)
        self.delistore = DeliStore(self.prefs.getUsername(),
                                   self.prefs.getPassword())
        self.delistore.setSortMethod(self.prefs.getSortMethod())
        self.delistore.setReversed(self.prefs.getReversed())


    def addKDeliTag(self, ktag):
        self.deliTags.append(ktag)

    def mousePressEvent(self, qme):
        button = qme.button()
        if (button == QMouseEvent.RightButton):
            menu = self.contextMenu()
            self.contextMenuAboutToShow(menu)
            menu.popup(qme.globalPos())
        if (button == QMouseEvent.LeftButton):
            self.contextMenuAboutToShow(self.tagspopupmenu)
            self.tagspopupmenu.popup(qme.globalPos())

    def refreshTimer(self, new_time):
        self.prefs.setReloadTime(new_time)
        self.refresh_timer.changeInterval(60000*new_time)

    def refreshData(self):
        print "data refreshed"
        self.tagspopupmenu.clear()

        #There's no reason to update the data from the Net...
        if not (self.prefs.getLastLoginStatus() or self.prefs.login_updated):
            self.tagspopupmenu.insertTitle("Login Required")
            return

        try:
            # Drop the stored tags
            self.deliTags = list()
            self.recentPosts = list()
            self.tagspopupmenu.insertTitle(str(self.prefs.getUsername())+"'s Tags")
            #self.tagspopupmenu.insertSeparator()
            minimum_tags = self.prefs.getMinPosts()
            if self.startup == True:
                self.delistore.fetchmethod = "disk"
                self.startup = False
            else:
                self.delistore.fetchmethod = "net"
            self.delistore.refreshData()
            for x in self.delistore.getTags():
                #show only tags with a minimum number of posts.
                if (x.getNumPosts() >= minimum_tags):
                    tmp = KDeliTag(x, self)
                    self.addKDeliTag(tmp)
                    tmp.plug(self.tagspopupmenu)
            #self.tagspopupmenu.insertSeparator()
            self.tagspopupmenu.insertTitle("Recent Posts")
            self.ksarecentposts = KSelectAction("List")
            self.ksarecentposts.plug(self.tagspopupmenu)
            for x in self.delistore.getRecentPosts():
                tmp = KDeliPost(x)
                self.recentPosts.append(tmp)
                tmp.plug(self.ksarecentposts.popupMenu())
            #self.tagspopupmenu.insertTitle("Connected with " + str(self.prefs.getUsername()) )
            #self.tagspopupmenu.insertTitle("Data loaded from " + self.delistore.succesfullmethod )

            # All went fine... keep it track.
            self.prefs.setLastLoginStatus(True)
            self.prefs.sync()

        except urllib2.HTTPError, e:
            if e.code == 503:
                KMessageBox.error(None,"Connection to Del.icio.us failed!")
                self.prefs.setLastLoginStatus(False)
                self.tagspopupmenu.insertTitle("Login Required")
                return
             # Wrong account information given.
            KMessageBox.error(None,"Wrong Username or Password!")
            # Store this info to not reload this login the next time.
            self.prefs.setLastLoginStatus(False)
            self.tagspopupmenu.insertTitle("Login Required")

        except:
            # Net connection problems.
            KMessageBox.error(None,"Internet connection required!")
            self.tagspopupmenu.insertTitle("Net Problems")

        



